#ifdef GL_ES   
    #define LOWP lowp
    precision mediump float;
#else
    #define LOWP
#endif
    
varying LOWP vec4 v_color;
varying vec2 v_texCoords;

uniform sampler2D u_texture;
uniform sampler2D u_mask;
uniform vec2 u_sizeAtlasMask;
uniform vec2 u_posMask;
uniform vec2 u_sizeMask;
uniform vec2 u_sizeAtlasTex;
uniform vec2 u_posTex;
uniform vec2 u_sizeTex;

uniform float u_scaleMask;


void main(){
	
	vec4 texColor = texture2D(u_texture, v_texCoords);
	
	vec2 uvStartTex = u_posTex.xy / u_sizeAtlasTex.xy;
	vec2 uvSizeTex = u_sizeTex.xy / u_sizeAtlasTex.xy;
	
	vec2 uvStartMask = u_posMask.xy / u_sizeAtlasMask.xy;
	vec2 uvSizeMask = u_sizeMask.xy / u_sizeAtlasMask.xy;
	
	vec2 ratio = (uvSizeMask.xy / uvSizeTex.xy) * (u_sizeTex.xy / u_sizeMask.xy);
	float deltaY = (u_sizeMask.y * u_scaleMask - u_sizeTex.y) / u_sizeAtlasTex.y;
 
	float xTex = v_texCoords.x - uvStartTex.x;
	float yTex = v_texCoords.y - uvStartTex.y + deltaY;
	
	vec2 texCoordsMask = vec2(uvStartMask.x + xTex / u_scaleMask * ratio.x, uvStartMask.y + yTex / u_scaleMask * ratio.y);
	
	float mask = texture2D(u_mask, texCoordsMask).a;

	gl_FragColor = vec4(vec3(v_color * texColor), mask * texColor.a);
}