#ifdef GL_ES
precision mediump float;
#endif

varying vec2 v_fragTextureCoords;
varying vec2 v_fragTrueCoords; // [0..1]
varying vec4 v_color;

uniform sampler2D u_background;  // atlas
uniform sampler2D u_mask;  // atlas

uniform vec2 u_shift;  // shift crumpled mask

uniform vec4 u_fragBounds; //x y width height  [0..inf]
uniform vec4 u_maskBounds; //x y width height  [0..inf]
uniform vec2 u_fragAtlasSize; // width height  [0..inf]
uniform vec2 u_maskAtlasSize; // width height  [0..inf]

void main(){
    vec2 maskPosition = u_maskBounds.xy / u_maskAtlasSize; // [0..1]
    vec2 fragPixPosition = v_fragTrueCoords * u_fragBounds.zw;

    vec4 texColor = texture2D(u_background, v_fragTextureCoords);
    vec4 maskColor = texture2D(u_mask, maskPosition + u_shift + fragPixPosition / u_maskAtlasSize);

    if (texColor.a <= 0.65) // 0.7 instead of 1.0 to prevent strange borders and support custom shadows at the same time
        gl_FragColor = vec4(0.0);
    else
        gl_FragColor = maskColor;

    //gl_FragColor = texture2D(u_background, v_fragTrueCoords);//vec4(v_fragTextureCoords.x, v_fragTextureCoords.y, 1.0, 1.0);
}