#ifdef GL_ES
precision mediump float;
#endif

varying vec2 v_fragTextureCoords;
varying vec2 v_fragTrueCoords;
varying vec4 v_color;

uniform sampler2D u_texture;
uniform float u_progress;
uniform vec4 u_fragBounds;
uniform vec2 u_fragAtlasSize;

vec2 atlasToFragmentCoords(vec2 globalCoords, vec4 fragmentBounds, vec2 atlasSize){
    return (atlasSize * globalCoords - fragmentBounds.xy) / fragmentBounds.zw;
}

vec2 framentToAtlasCoords(vec2 localCoords, vec4 fragmentBounds, vec2 atlasSize){
    return (localCoords * fragmentBounds.zw + fragmentBounds.xy) / atlasSize;
}

void main() {
    if (v_fragTrueCoords.x < u_progress){
        //vec2 modifiedCoords = framentToAtlasCoords(v_fragTrueCoords + vec2(1.0-u_progress, 0.0), u_fragBounds, u_fragAtlasSize);
        vec4 textureColor = v_color;
        textureColor.a *= texture2D(u_texture, v_fragTextureCoords).a;
        gl_FragColor = textureColor;
    }else
        gl_FragColor = vec4(0.0);
}
