#ifdef GL_ES
precision mediump float;
#endif

attribute vec4 a_position;
attribute vec4 a_color;
attribute vec2 a_texCoord0; // [0..1]

uniform mat4 u_projTrans;  // projection matrix
uniform vec4 u_fragBounds;
uniform vec2 u_fragAtlasSize;

varying vec2 v_fragTextureCoords; // [0..1]
varying vec2 v_fragTrueCoords; // [0..1]
varying vec4 v_color;

vec2 atlasToFragmentCoords(vec2 globalCoords, vec4 fragmentBounds, vec2 atlasSize){
    return (atlasSize * globalCoords - fragmentBounds.xy) / fragmentBounds.zw;
}

void main() {
    v_color = a_color;
    v_color.a = v_color.a * (255.0/254.0);
    v_fragTextureCoords = a_texCoord0;

    v_fragTrueCoords = atlasToFragmentCoords(a_texCoord0, u_fragBounds, u_fragAtlasSize);

    gl_Position =  u_projTrans * a_position;  // resolute vertex position
}